// COOL24+24 (v1.0)
// To the extent possible under law, the author has waived all copyright and
// related or neighboring right to this work (CC0).

// card.js: カードの画像を管理するクラス定義
class CardGraphic {    
  constructor(suite, number) {
    this.width = 260;
    this.height = 400;
    this.image = document.createElement('canvas')
    this.image.height = this.height;
    this.image.width = this.width;
    let ctx = this.image.getContext('2d');
    ctx.fillStyle = "black";
    ctx.fillRect(0, 0, this.width, this.height);
    ctx.fillStyle = "white";
    ctx.fillRect(2, 2, this.width - 4, this.height - 4);
    this.loadAndDrawImage(ctx, "cards/" + suiteNames[suite], 2, 8);
    this.loadAndDrawImage(ctx, "cards/" + suiteNames[suite] + numberNames[number], 2, 142);
    ctx.font = '112px "Bauhaus 93"';
    ctx.textAlign = 'center';
    ctx.fillStyle = suiteColors[suite];
    ctx.fillText(numberNames[number], 194, 110);
  }

  // 指定した場所にカードを描画
  draw(ctx, x, y, w = 1.0) {
    let ww = w * this.width;
    ctx.drawImage(this.image, 0, 0, this.width, this.height, x + (this.width - ww) / 2, y, ww, this.height);
  }

  // 画像の読み出しとカードの準備を非同期で行う
  async loadAndDrawImage(ctx, src, x, y) {
    let img = new Image();
    let imgpromise = (img) => {
      return new Promise((resolve, reject) => {
        img.onload = () => { resolve(img); };
        img.onerror = () => {
          img.onerror = () => { img.onerror = null; resolve(img); };
          img.src = img.src.substring(0, img.src.length - 4) + ".jpg";
        };
      })
    };
    img.src = src + ".png";
    await imgpromise(img);
    ctx.drawImage(img, x, y);
  }
}